
(cffi:load-foreign-library "user32.dll")

(cffi:defcfun
  ("EnumWindows" enum-windows)
  :int
  (func :pointer)
  (lparam :long))

;;; NOTE: this callback requires stdcall but
;;; cffi only supports cdecl; hence invoking
;;; this callback eventually causes a crash
;;;
(cffi:defcallback test-callback :int ((hwnd :pointer) (lparam :long))
  (format t "test-callback invoked~%")
  1)

(defun callback-test ()
  (enum-windows (cffi:get-callback 'test-callback) 0))
